package com.yutou.bilibili.mybatis.Bili.mybatis.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BilibiliLiveInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public BilibiliLiveInfoExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRoomidIsNull() {
            addCriterion("roomid is null");
            return (Criteria) this;
        }

        public Criteria andRoomidIsNotNull() {
            addCriterion("roomid is not null");
            return (Criteria) this;
        }

        public Criteria andRoomidEqualTo(Integer value) {
            addCriterion("roomid =", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidNotEqualTo(Integer value) {
            addCriterion("roomid <>", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidGreaterThan(Integer value) {
            addCriterion("roomid >", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidGreaterThanOrEqualTo(Integer value) {
            addCriterion("roomid >=", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidLessThan(Integer value) {
            addCriterion("roomid <", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidLessThanOrEqualTo(Integer value) {
            addCriterion("roomid <=", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidIn(List<Integer> values) {
            addCriterion("roomid in", values, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidNotIn(List<Integer> values) {
            addCriterion("roomid not in", values, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidBetween(Integer value1, Integer value2) {
            addCriterion("roomid between", value1, value2, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidNotBetween(Integer value1, Integer value2) {
            addCriterion("roomid not between", value1, value2, "roomid");
            return (Criteria) this;
        }

        public Criteria andPopularIsNull() {
            addCriterion("popular is null");
            return (Criteria) this;
        }

        public Criteria andPopularIsNotNull() {
            addCriterion("popular is not null");
            return (Criteria) this;
        }

        public Criteria andPopularEqualTo(Integer value) {
            addCriterion("popular =", value, "popular");
            return (Criteria) this;
        }

        public Criteria andPopularNotEqualTo(Integer value) {
            addCriterion("popular <>", value, "popular");
            return (Criteria) this;
        }

        public Criteria andPopularGreaterThan(Integer value) {
            addCriterion("popular >", value, "popular");
            return (Criteria) this;
        }

        public Criteria andPopularGreaterThanOrEqualTo(Integer value) {
            addCriterion("popular >=", value, "popular");
            return (Criteria) this;
        }

        public Criteria andPopularLessThan(Integer value) {
            addCriterion("popular <", value, "popular");
            return (Criteria) this;
        }

        public Criteria andPopularLessThanOrEqualTo(Integer value) {
            addCriterion("popular <=", value, "popular");
            return (Criteria) this;
        }

        public Criteria andPopularIn(List<Integer> values) {
            addCriterion("popular in", values, "popular");
            return (Criteria) this;
        }

        public Criteria andPopularNotIn(List<Integer> values) {
            addCriterion("popular not in", values, "popular");
            return (Criteria) this;
        }

        public Criteria andPopularBetween(Integer value1, Integer value2) {
            addCriterion("popular between", value1, value2, "popular");
            return (Criteria) this;
        }

        public Criteria andPopularNotBetween(Integer value1, Integer value2) {
            addCriterion("popular not between", value1, value2, "popular");
            return (Criteria) this;
        }

        public Criteria andUserindexIsNull() {
            addCriterion("userIndex is null");
            return (Criteria) this;
        }

        public Criteria andUserindexIsNotNull() {
            addCriterion("userIndex is not null");
            return (Criteria) this;
        }

        public Criteria andUserindexEqualTo(Integer value) {
            addCriterion("userIndex =", value, "userindex");
            return (Criteria) this;
        }

        public Criteria andUserindexNotEqualTo(Integer value) {
            addCriterion("userIndex <>", value, "userindex");
            return (Criteria) this;
        }

        public Criteria andUserindexGreaterThan(Integer value) {
            addCriterion("userIndex >", value, "userindex");
            return (Criteria) this;
        }

        public Criteria andUserindexGreaterThanOrEqualTo(Integer value) {
            addCriterion("userIndex >=", value, "userindex");
            return (Criteria) this;
        }

        public Criteria andUserindexLessThan(Integer value) {
            addCriterion("userIndex <", value, "userindex");
            return (Criteria) this;
        }

        public Criteria andUserindexLessThanOrEqualTo(Integer value) {
            addCriterion("userIndex <=", value, "userindex");
            return (Criteria) this;
        }

        public Criteria andUserindexIn(List<Integer> values) {
            addCriterion("userIndex in", values, "userindex");
            return (Criteria) this;
        }

        public Criteria andUserindexNotIn(List<Integer> values) {
            addCriterion("userIndex not in", values, "userindex");
            return (Criteria) this;
        }

        public Criteria andUserindexBetween(Integer value1, Integer value2) {
            addCriterion("userIndex between", value1, value2, "userindex");
            return (Criteria) this;
        }

        public Criteria andUserindexNotBetween(Integer value1, Integer value2) {
            addCriterion("userIndex not between", value1, value2, "userindex");
            return (Criteria) this;
        }

        public Criteria andVipuserindexIsNull() {
            addCriterion("vipUserIndex is null");
            return (Criteria) this;
        }

        public Criteria andVipuserindexIsNotNull() {
            addCriterion("vipUserIndex is not null");
            return (Criteria) this;
        }

        public Criteria andVipuserindexEqualTo(Integer value) {
            addCriterion("vipUserIndex =", value, "vipuserindex");
            return (Criteria) this;
        }

        public Criteria andVipuserindexNotEqualTo(Integer value) {
            addCriterion("vipUserIndex <>", value, "vipuserindex");
            return (Criteria) this;
        }

        public Criteria andVipuserindexGreaterThan(Integer value) {
            addCriterion("vipUserIndex >", value, "vipuserindex");
            return (Criteria) this;
        }

        public Criteria andVipuserindexGreaterThanOrEqualTo(Integer value) {
            addCriterion("vipUserIndex >=", value, "vipuserindex");
            return (Criteria) this;
        }

        public Criteria andVipuserindexLessThan(Integer value) {
            addCriterion("vipUserIndex <", value, "vipuserindex");
            return (Criteria) this;
        }

        public Criteria andVipuserindexLessThanOrEqualTo(Integer value) {
            addCriterion("vipUserIndex <=", value, "vipuserindex");
            return (Criteria) this;
        }

        public Criteria andVipuserindexIn(List<Integer> values) {
            addCriterion("vipUserIndex in", values, "vipuserindex");
            return (Criteria) this;
        }

        public Criteria andVipuserindexNotIn(List<Integer> values) {
            addCriterion("vipUserIndex not in", values, "vipuserindex");
            return (Criteria) this;
        }

        public Criteria andVipuserindexBetween(Integer value1, Integer value2) {
            addCriterion("vipUserIndex between", value1, value2, "vipuserindex");
            return (Criteria) this;
        }

        public Criteria andVipuserindexNotBetween(Integer value1, Integer value2) {
            addCriterion("vipUserIndex not between", value1, value2, "vipuserindex");
            return (Criteria) this;
        }

        public Criteria andGiftuserIsNull() {
            addCriterion("giftUser is null");
            return (Criteria) this;
        }

        public Criteria andGiftuserIsNotNull() {
            addCriterion("giftUser is not null");
            return (Criteria) this;
        }

        public Criteria andGiftuserEqualTo(Integer value) {
            addCriterion("giftUser =", value, "giftuser");
            return (Criteria) this;
        }

        public Criteria andGiftuserNotEqualTo(Integer value) {
            addCriterion("giftUser <>", value, "giftuser");
            return (Criteria) this;
        }

        public Criteria andGiftuserGreaterThan(Integer value) {
            addCriterion("giftUser >", value, "giftuser");
            return (Criteria) this;
        }

        public Criteria andGiftuserGreaterThanOrEqualTo(Integer value) {
            addCriterion("giftUser >=", value, "giftuser");
            return (Criteria) this;
        }

        public Criteria andGiftuserLessThan(Integer value) {
            addCriterion("giftUser <", value, "giftuser");
            return (Criteria) this;
        }

        public Criteria andGiftuserLessThanOrEqualTo(Integer value) {
            addCriterion("giftUser <=", value, "giftuser");
            return (Criteria) this;
        }

        public Criteria andGiftuserIn(List<Integer> values) {
            addCriterion("giftUser in", values, "giftuser");
            return (Criteria) this;
        }

        public Criteria andGiftuserNotIn(List<Integer> values) {
            addCriterion("giftUser not in", values, "giftuser");
            return (Criteria) this;
        }

        public Criteria andGiftuserBetween(Integer value1, Integer value2) {
            addCriterion("giftUser between", value1, value2, "giftuser");
            return (Criteria) this;
        }

        public Criteria andGiftuserNotBetween(Integer value1, Integer value2) {
            addCriterion("giftUser not between", value1, value2, "giftuser");
            return (Criteria) this;
        }

        public Criteria andSubtimeIsNull() {
            addCriterion("subtime is null");
            return (Criteria) this;
        }

        public Criteria andSubtimeIsNotNull() {
            addCriterion("subtime is not null");
            return (Criteria) this;
        }

        public Criteria andSubtimeEqualTo(Date value) {
            addCriterion("subtime =", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeNotEqualTo(Date value) {
            addCriterion("subtime <>", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeGreaterThan(Date value) {
            addCriterion("subtime >", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeGreaterThanOrEqualTo(Date value) {
            addCriterion("subtime >=", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeLessThan(Date value) {
            addCriterion("subtime <", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeLessThanOrEqualTo(Date value) {
            addCriterion("subtime <=", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeIn(List<Date> values) {
            addCriterion("subtime in", values, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeNotIn(List<Date> values) {
            addCriterion("subtime not in", values, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeBetween(Date value1, Date value2) {
            addCriterion("subtime between", value1, value2, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeNotBetween(Date value1, Date value2) {
            addCriterion("subtime not between", value1, value2, "subtime");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}